;COM_DELAY	    equ	.82

WAIT_COM:				; wait 1/9600 sec = 104us
    MOVLW	.26
    MOVWF	tmp0
COM_WAIT_1:
    DECFSZ	tmp0,F
    GOTO	COM_WAIT_1
    RETLW	0
    
test_com:
    MOVLW	STX			; start of text
    MOVWF	COM_BUF
    CALL	send_byte
    
    MOVF	temp,W			; start of text
    MOVWF	COM_BUF
    CALL	send_byte

    MOVLW	ETX			; start of text
    MOVWF	COM_BUF
    CALL	send_byte    
    
    INCF	temp,F
    
wait_test_1:    
    MOVLW	.5
    MOVWF	cnt1
    MOVLW	optreg | b'00000110'    ;prescaler 128 assigned to T0
    OPTION
    CLRF	TMR0
wait_test_2:
    MOVF	TMR0,0
    BTFSC	STATUS,Z
    GOTO	wait_test_2
wait_test_3:
    MOVF	TMR0,0
    BTFSS	STATUS,Z
    GOTO	wait_test_3
    DECF	cnt1,F
    BTFSS	STATUS,Z
    GOTO	wait_test_2
    
    GOTO	test_com
    
    
; --------------------------------------------------------    
print_data:
    MOVLW	STX			;start of text
    MOVWF	COM_BUF
    CALL	send_byte
    
    ;MOVLW	.0			;start of text
    MOVF	TLSB,W
    MOVWF	COM_BUF
    CALL	send_byte   
    
    ;MOVLW	.0
    MOVF	TMSB,W
    MOVWF	COM_BUF
    CALL	send_byte
    
    MOVF	tmpcnt,W
    MOVWF	COM_BUF
    CALL	send_byte

    MOVF	temp,W
    MOVWF	COM_BUF
    CALL	send_byte
    
    ;MOVLW	.0
    MOVF	temp_real,W
    MOVWF	COM_BUF
    CALL	send_byte

    ;MOVLW	.0
    MOVF	state_reg,W
    MOVWF	COM_BUF
    CALL	send_byte

    MOVLW	ETX
    ;MOVF	temp,W
    MOVWF	COM_BUF
    CALL	send_byte
    
    GOTO	print_data_end

send_byte: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    BCF		GPIO,COM_TX
    CALL	WAIT_COM
    MOVLW	.8
    MOVWF	COM_PTR
    GOTO	$+1
    GOTO	$+1
COM_LOOP_1:
    NOP
    BTFSS	COM_BUF,0
    GOTO	COM_LOOP_2
    BSF		GPIO,COM_TX
    GOTO	COM_LOOP_3
COM_LOOP_2:
    BCF		GPIO,COM_TX
    NOP
COM_LOOP_3:
    CALL	WAIT_COM
    RRF		COM_BUF,F
    DECFSZ	COM_PTR,F
    GOTO	COM_LOOP_1
COM_LOOP_END:
    BSF		GPIO,COM_TX		;send stop byte
    CALL	WAIT_COM
    ;WAIT	.2550
    DUC		2550
    RETLW	0     
; --------------------------------------------------------    